---
- name: Clone Passenger repository
  git:
    repo: "{{ passenger_repo }}"
    version: "{{ passenger_repo_ver }}"
    dest: "{{ passenger_home }}"
    update: "{{ passenger_update }}"
  register: repochkout
  until: repochkout is succeeded
  retries: "{{ network_max_retries }}"
- name: Set system Ruby for Passenger
  copy:
    dest: "{{ passenger_home }}/.ruby-version"
    content: "{{ sys_ruby_version }}"
- name: Stat rbenv
  stat:
    path: /usr/bin/rbenv
  register: st
- name: Set RBENV_ROOT
  set_fact: rbenv_root="{{ (st.stat.lnk_target | dirname) | dirname }}"
- name: Verify Rake installed
  shell: rbenv exec gem list -i rake
  environment:
    RBENV_VERSION: "{{ sys_ruby_version }}"
    RBENV_ROOT: "{{ rbenv_root }}"
  register: o
  changed_when: false
  failed_when: false
- name: Install Rake
  shell: rbenv exec gem install -E --no-document rake
  environment:
    RBENV_VERSION: "{{ sys_ruby_version }}"
    RBENV_ROOT: "{{ rbenv_root }}"
  when: o.rc == 1
  # Use system Ruby
- name: Build Passenger
  shell: rbenv exec rake -j"{{ compile_max_jobs | quote }}" apache2
  args:
    chdir: "{{ passenger_home }}"
  environment:
    RBENV_VERSION: "{{ sys_ruby_version }}"
    TMPDIR: "{{ build_tmpdir }}"
    RBENV_ROOT: "{{ rbenv_root }}"
  notify: Restart apache
  when: repochkout.changed

# Necessary for Python support
- block:
  - name: Include Python configuration
    include_vars:
      file: "{{ playbook_dir }}/roles/software/pyenv/defaults/main.yml"
      name: pyenv
  - set_fact:
      passenger_python: "{{ pyenv.git_target }}/shims/python"
  when: anyversion_python
# End Python support

- name: Copy Passenger configuration
  template:
    src: templates/passenger.conf.j2
    dest: "{{ passenger_apache_config }}"
    force: yes
  notify: Restart apache
- name: Create Passenger directories
  file:
    path: "{{ passenger_home }}/{{ item }}"
    state: directory
  with_items:
    - logs
    - sockets
- file:
    path: "{{ passenger_fst_log_location | dirname}}"
    state: directory
- name: Link passenger log to {{ apnscp_shared_root }}
  file:
    path: "{{ passenger_fst_log_location }}"
    state: link
    src: "{{ passenger_log_location }}"
